# This file is for testing the openstack api access

import openstack

from implementation.network.OpenstackFloatingIPManager import OpenstackFloatingIPManager
from implementation.network.OpenstackNetworkManager import OpenstackNetworkManager
from implementation.network.OpenstackPortManager import OpenstackPortManager
from implementation.network.OpenstackRouterManager import OpenstackRouterManager
from implementation.network.OpenstackSubnetManager import OpenstackSubnetManager

os = openstack.connect(cloud='openstack')

router_manager = OpenstackRouterManager(os)
network_manager = OpenstackNetworkManager(os)
subnet_manager = OpenstackSubnetManager(os)
port_manager = OpenstackPortManager(os)
floating_ip_manager = OpenstackFloatingIPManager(os)

'''
    Network setup steps:
        - Create inner network
        - Create subnet for inner network
        - Create router
        - Add public network to router as gateway
        - Add inner subnet to router as interface
        - Add interface (or port?) to vm
        - Get the port of the vm
        - Create floating ip to public network
        - Associate floating ip and vm port
'''

#router = router_manager.create()
router = router_manager.get('3ee87bcd-b1b5-4e14-86a1-ce691bd3e5a2')

print('Router:')
print('\t%s' % router)

#network = network_manager.create()
public_network = network_manager.get('3b349c93-8b2c-4abd-b8ce-22b7db4cca98')
inner_network = network_manager.get('8df0d7ab-7d56-4496-aca0-317af66b3ebc')

print('Network:')
print('\tPublic: %s' % public_network)
print('\tInner: %s' % inner_network)

#subnet = subnet_manager.create(network.id, 4, '10.34.0.0/16')
public_subnet = subnet_manager.get('8a7e05f8-6358-48f7-9104-990d350425a0')
inner_subnet = subnet_manager.get('34911571-c929-4433-b4e6-305fcb585a91') #create(inner_network.id, 4, '10.0.0.0/24')

print('Subnet:')
print('\tPublic: %s' % public_subnet)
print('\tInner: %s' % inner_subnet)

vm_port = port_manager.get('85202d6d-7aa0-44bc-a5eb-78b0519066c5') # inner

print('Port:')
print('\tVM: %s' % vm_port)

#floating_ip = floating_ip_manager.create(public_network.id)
floating_ip = floating_ip_manager.get('fe1e329f-aedb-4b3e-a649-9fec8eb3ece5')

print('Floating IP:')
print('\tFloating IP: %s' % floating_ip)


#print(router_manager.add_interface(router.id, inner_subnet.id)) # TODO: fix error msg
#print(router_manager.add_gateway(router.id, public_network.id)) # TODO: fix it!

# print(floating_ip_manager.update(floating_ip.id, {
#    'port_id': vm_port.id
# }))